/**
 * @license
 * Copyright (c) 2016 Łukasz Kurowski <crackcomm@gmail.com>
 */
"use strict";
const fs = require("fs-extra-promise");
const escore_util_1 = require("escore-util");
/**
 * Packs schema in current directory to JavaScript.
 */
function packSchema() {
    return escore_util_1.glob(`schema/**/*.json`)
        .then(files => Promise.all(files.map(filepath => fs.readJSONAsync(filepath))))
        .then(schemas => packageToSchemaJS(schemas))
        .then(schemas => fs.writeFileAsync('_schema.js', schemas))
        .then(() => console.log('done'));
}
exports.packSchema = packSchema;
function authorName(author) {
    return typeof author === 'string' ? author : `${author.name} <${author.email}>`;
}
function schemaTemplate(pkg, schemas) {
    return `
/*
 * @license
 * Copyright (c) ${new Date().getFullYear()} ${authorName(pkg.author)}
 */

module.exports = ${JSON.stringify(schemas, null, '  ')};

    `.trim();
}
function packageToSchemaJS(schemas) {
    return fs.readJSONAsync('package.json')
        .then(pkg => schemaTemplate(pkg, schemas));
}
